package com.frist008.nixlibrary;

import android.support.annotation.LayoutRes;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

public final class NixCreatorHolder {

	@LayoutRes
	private final Class<? extends NixHolder> holderClass;
	private final int layoutRes;

	public NixCreatorHolder(Class<? extends NixHolder> holderClass, @LayoutRes int layoutRes) {
		this.layoutRes = layoutRes;
		this.holderClass = holderClass;
	}

	public NixHolder newView(LayoutInflater inflater, ViewGroup parent) {
		View parentView = inflater.inflate(layoutRes, parent, false);
		try {
			return holderClass.getConstructor(View.class).newInstance(parentView);
		} catch (Exception e) {
			throw new RuntimeException(
					"Maybe: Not found " + holderClass.getName()
					+ " constructor(View parentView); or Exception ", e);
		}
	}
}
