package com.frist008.nixlibrary;

import android.app.Activity;
import android.content.Context;
import android.content.res.Resources;
import android.support.annotation.StringRes;
import android.view.View;

@SuppressWarnings("UnusedDeclaration")
public abstract class NixHolder<Adapter extends NixAdapter, ContentBean> {

	private int id;
	private int position;
	private int viewType;

	private final View parentView;
	private boolean expanded;
	private boolean lastExpandedChild;
	private Adapter adapter;

	public NixHolder(View parentView) {
		this.parentView = parentView;
		parentView.setTag(this);
	}

	public abstract void bindView(ContentBean contentBean);

	public View getParentView() {
		return parentView;
	}

	public Context getContext() {
		return parentView.getContext();
	}

	protected <ViewActivity extends Activity> ViewActivity getActivity(Class<ViewActivity> viewActivity) {
		return viewActivity.cast(getContext());
	}

	public Resources getResources() {
		return getContext().getResources();
	}

	public String getString(@StringRes int stringRes, Object... obj) {
		return getContext().getString(stringRes, obj);
	}

	public String getString(@StringRes int stringRes) {
		return getContext().getString(stringRes);
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public int getViewType() {
		return viewType;
	}

	public void setViewType(int viewType) {
		this.viewType = viewType;
	}

	public int getPosition() {
		return position;
	}

	public void setPosition(int position) {
		this.position = position;
	}

	public void setExpanded(boolean expanded) {
		this.expanded = expanded;
	}

	public boolean isExpanded() {
		return expanded;
	}

	public void setLastExpandedChild(boolean lastExpandedChild) {
		this.lastExpandedChild = lastExpandedChild;
	}

	public boolean isLastExpandedChild() {
		return lastExpandedChild;
	}

	public void setAdapter(Adapter adapter) {
		this.adapter = adapter;
	}

	public Adapter getAdapter() {
		return adapter;
	}

}
