package com.frist008.nixlibrary;

import android.database.Cursor;
import android.support.annotation.NonNull;
import android.view.View;

import com.frist008.nixlibrary.database.NixTableOrViewBean;

@SuppressWarnings("UnusedDeclaration")
public abstract class NixOrmHolder<Adapter extends NixAdapter, Bean extends NixTableOrViewBean>
		extends NixHolder<Adapter, Cursor> {

	private final Bean emptyBean;
	private Bean bean;

	public NixOrmHolder(View parentView, Class<Bean> beanClass) {
		super(parentView);
		this.emptyBean = newEmptyBeanWithReflection(beanClass);
	}

	public final Bean newEmptyBeanWithReflection(@NonNull Class<Bean> beanClass) {
		try {
			return beanClass.getConstructor().newInstance();
		} catch (Exception e) {
			throw new RuntimeException(beanClass.getClass().getSimpleName()
			                           + " Bean is not exist empty constructor");
		}
	}

	@Override
	public void bindView(Cursor cursor) {
		@SuppressWarnings("unchecked")
		Bean bean = (Bean) emptyBean.newEmptyBean().get(cursor);
		this.bean = bean;
		bindView(cursor, bean);
	}

	protected abstract void bindView(Cursor cursor, Bean bean);

	public Bean getBean() {
		return bean;
	}
}
