package com.frist008.nixlibrary.array;

import android.content.Context;
import android.support.annotation.LayoutRes;
import android.support.annotation.NonNull;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;

import com.frist008.nixlibrary.NixAdapter;
import com.frist008.nixlibrary.NixArrayBean;
import com.frist008.nixlibrary.NixCreatorHolder;
import com.frist008.nixlibrary.NixHolder;

import java.util.List;

@SuppressWarnings("unused")
public class NixArrayAdapter extends ArrayAdapter<NixArrayBean> implements NixAdapter<List> {

	@NonNull
	private final List<? extends NixArrayBean> contentList;
	private final NixCreatorHolder creatorHolder;

	@SuppressWarnings("unchecked")
	public NixArrayAdapter(@NonNull Context context,
	                       @NonNull List<? extends NixArrayBean> contentList,
	                       @NonNull Class<? extends NixHolder> holderClass,
	                       @LayoutRes int layoutRes) {
		super(context, 0, (List<NixArrayBean>) contentList);
		this.contentList = contentList;
		this.creatorHolder = new NixCreatorHolder(holderClass, layoutRes);
	}

	@SuppressWarnings({"unchecked", "deprecation"})
	@Deprecated
	@Override
	public View getView(int position, View parentView, ViewGroup parent) {
		NixHolder holder = parentView == null
		                   ? newView(LayoutInflater.from(getContext()), parent, position)
		                   : (NixHolder) parentView.getTag();
		NixArrayBean content = contentList.get(position);

		holder.setPosition(position);
		holder.setViewType(content.getViewType());

		bindView(holder, content);

		return holder.getParentView();
	}

	@NonNull
	protected List<? extends NixArrayBean> getContentList() {
		return contentList;
	}

	@Deprecated
	@SuppressWarnings("unchecked")
	@NonNull
	protected NixHolder newView(LayoutInflater inflater, ViewGroup parent, int position) {
		return creatorHolder.newView(inflater, parent);
	}

	@Deprecated
	@SuppressWarnings("unchecked")
	protected void bindView(NixHolder viewHolder, NixArrayBean content) {
		viewHolder.setAdapter(this);
		viewHolder.bindView(content);
	}

	@Override
	public List<? extends NixArrayBean> getData() {
		return contentList;
	}

	protected <Bean extends NixArrayBean> Bean getItem(int position, Class<Bean> beanClass) {
		return beanClass.cast(getItem(position));
	}
}
