package com.frist008.nixlibrary.array;

import android.content.Context;
import android.support.annotation.NonNull;
import android.util.SparseArray;
import android.view.LayoutInflater;
import android.view.ViewGroup;

import com.frist008.nixlibrary.NixArrayBean;
import com.frist008.nixlibrary.NixCreatorHolder;
import com.frist008.nixlibrary.NixException;
import com.frist008.nixlibrary.NixHolder;
import com.frist008.nixlibrary.NixMultiCreatorHolder;

import java.util.List;

@SuppressWarnings("unused")
public class NixMultiArrayAdapter extends NixArrayAdapter {

	private final SparseArray<NixCreatorHolder> typeItemArr;

	@SuppressWarnings("ConstantConditions")
	public NixMultiArrayAdapter(Context context,
	                            NixMultiCreatorHolder typeMultiItemArr,
	                            List<NixArrayBean> contentList) {
		super(context, contentList, null, 0);
		this.typeItemArr = typeMultiItemArr.getCreatorHolderSparseArray();

		if (typeItemArr.size() == 0) {
			throw new NixException("SparseArray not valid length (maybe SparseArray == 0?)");
		}
	}

	@Override
	public int getViewTypeCount() {
		return typeItemArr.size();
	}

	/**
	 * @param position - This position.
	 * @return An integer representing the type of View. Two views should share the same type if one
	 * can be converted to the other in getView. Note: Integers must be in the range 0 to
	 * getViewTypeCount - 1 else ArrayIndexOutOfBoundsException. IGNORE_ITEM_VIEW_TYPE can also be
	 * returned.
	 */
	@Override
	public int getItemViewType(int position) {
		return getContentList().get(position).getViewType();
	}

	@SuppressWarnings({"unchecked", "deprecation"})
	@Deprecated
	@NonNull
	@Override
	protected NixHolder<NixMultiArrayAdapter, NixArrayBean> newView(LayoutInflater inflater,
	                                                                ViewGroup parent,
	                                                                int position) {
		int viewType = getContentList().get(position).getViewType();
		return typeItemArr.get(viewType).newView(inflater, parent);
	}
}
