package com.frist008.nixlibrary.cursor;

import android.content.Context;
import android.database.Cursor;
import android.support.annotation.LayoutRes;
import android.support.annotation.NonNull;
import android.support.v4.widget.CursorAdapter;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import com.frist008.nixlibrary.NixAdapter;
import com.frist008.nixlibrary.NixCreatorHolder;
import com.frist008.nixlibrary.NixHolder;
import com.frist008.nixlibrary.database.NixWhere;

@SuppressWarnings("unused")
public class NixCursorAdapter extends CursorAdapter implements NixAdapter<Cursor> {

	private final NixCreatorHolder creatorHolder;

	public NixCursorAdapter(Context context,
	                        @NonNull Class<? extends NixHolder> holderClass,
	                        @LayoutRes int layoutRes) {
		this(context, null, holderClass, layoutRes);
	}

	public NixCursorAdapter(Context context,
	                        Cursor cursor,
	                        @NonNull Class<? extends NixHolder> holderClass,
	                        @LayoutRes int layoutRes) {
		super(context, cursor, false);
		this.creatorHolder = new NixCreatorHolder(holderClass, layoutRes);
	}

	@Deprecated
	@Override
	public View newView(Context context, Cursor cursor, ViewGroup parent) {
		return creatorHolder.newView(LayoutInflater.from(context), parent).getParentView();
	}

	@SuppressWarnings("unchecked")
	@Deprecated
	@Override
	public void bindView(View view, Context context, Cursor cursor) {
		NixHolder holder = (NixHolder) view.getTag();
		holder.setId(cursor.getInt(cursor.getColumnIndex(NixWhere.NixCols.COLUMN_ID)));
		holder.setPosition(cursor.getPosition());
		holder.setAdapter(this);
		holder.bindView(cursor);
	}

	@Override
	public Cursor getData() {
		return getCursor();
	}
}
