package com.frist008.nixlibrary.cursor.sticky;

import android.content.Context;
import android.database.Cursor;
import android.support.annotation.NonNull;
import android.support.annotation.Nullable;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;

import com.frist008.nixlibrary.NixHolder;

@SuppressWarnings("unused")
final class HeaderCursorAdapterUtils {

	@NonNull
	public static View getHeaderView(@NonNull HeaderAdapter adapter,
	                                 int position,
	                                 @Nullable View parentView,
	                                 ViewGroup parent) {
		Context context = parent.getContext();
		int viewType = getViewTypeHeader(adapter, position);

		LayoutInflater inflater = LayoutInflater.from(context);
		NixHolder holder = adapter.newHeaderView(inflater, parent, position, viewType);

		holder.getParentView().setTag(holder);
		holder.setViewType(viewType);
		holder.setPosition(position);

		Cursor cursor = adapter.getCursor();

		if (cursor != null && cursor.moveToPosition(position)) {
			adapter.bindHeaderView(holder, adapter.getCursor());
		}

		return holder.getParentView();
	}

	@SuppressWarnings("ConstantConditions")
	public static int getViewTypeHeader(@NonNull HeaderAdapter adapter, int position) {
		Cursor cursor = adapter.getCursor();
		return cursor != null && cursor.moveToPosition(position)
		       ? adapter.getHeaderViewType(cursor, position)
		       : BaseAdapter.IGNORE_ITEM_VIEW_TYPE;
	}
}
