package com.frist008.nixlibrary.cursor.sticky;

import android.content.Context;
import android.database.Cursor;
import android.support.annotation.NonNull;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import com.frist008.nixlibrary.NixCreatorHolder;
import com.frist008.nixlibrary.NixException;
import com.frist008.nixlibrary.NixHolder;
import com.frist008.nixlibrary.NixMultiCreatorHolder;

@SuppressWarnings("unused")
public abstract class NixDoubleMultiStickyCursorAdapter extends NixMultiStickyCursorAdapter {

	private final NixMultiCreatorHolder typeHeaderArr = new NixMultiCreatorHolder();

	@SuppressWarnings("ConstantConditions")
	public NixDoubleMultiStickyCursorAdapter(Context context) {
		super(context, null, 0);
		fillTypeHeaderArr(typeHeaderArr);

		if (typeHeaderArr.getCreatorHolderSparseArray().size() == 0) {
			throw new NixException("SparseArray not valid length (maybe SparseArray == 0?)");
		}
	}

	protected abstract void fillTypeHeaderArr(NixMultiCreatorHolder typeHeaderArr);

	@Override
	protected int getItemViewType(Cursor cursor) {
		return getHeaderViewType(cursor, cursor.getPosition());
	}

	@NonNull
	@Override
	public NixHolder newHeaderView(@NonNull LayoutInflater inflater,
	                               ViewGroup parent,
	                               int position,
	                               int viewType) {
		NixCreatorHolder creatorHolder = typeHeaderArr.getCreatorHolderSparseArray().get(viewType);
		return creatorHolder == null
		       ? new NixEmptyHolder(new View(inflater.getContext()))
		       : creatorHolder.newView(inflater, parent);
	}

	private class NixEmptyHolder extends NixHolder {
		public NixEmptyHolder(View parentView) {
			super(parentView);
		}

		@Override
		public void bindView(Object o) { }
	}
}
