package com.frist008.nixlibrary.cursor.sticky;

import android.content.Context;
import android.database.Cursor;
import android.support.annotation.LayoutRes;
import android.support.annotation.NonNull;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import com.frist008.nixlibrary.NixCreatorHolder;
import com.frist008.nixlibrary.NixHolder;
import com.frist008.nixlibrary.cursor.NixMultiCursorAdapter;

@SuppressWarnings("unused")
public abstract class NixMultiStickyCursorAdapter extends NixMultiCursorAdapter
		implements HeaderAdapter {

	private final NixCreatorHolder creatorHeaderHolder;

	public NixMultiStickyCursorAdapter(Context context,
	                                   @NonNull Class<? extends NixHolder> holderHeaderClass,
	                                   @LayoutRes int headerLayoutRes) {
		super(context, null);
		this.creatorHeaderHolder = new NixCreatorHolder(holderHeaderClass, headerLayoutRes);
	}

	@Override
	public View getHeaderView(int position, View parentView, ViewGroup parent) {
		return HeaderCursorAdapterUtils.getHeaderView(this, position, parentView, parent);
	}

	@Override
	public long getHeaderId(int position) {
		return HeaderCursorAdapterUtils.getViewTypeHeader(this, position);
	}

	@NonNull
	@Override
	public NixHolder newHeaderView(@NonNull LayoutInflater inflater,
	                               ViewGroup parent,
	                               int position,
	                               int viewType) {
		return creatorHeaderHolder.newView(inflater, parent);
	}

	@SuppressWarnings("unchecked")
	@Deprecated
	@Override
	public void bindHeaderView(@NonNull NixHolder holder, Cursor cursor) {
		holder.setAdapter(this);
		holder.bindView(cursor);
	}
}
