package com.frist008.nixlibrary.cursor.sticky;

import android.content.Context;
import android.database.Cursor;
import android.support.annotation.LayoutRes;
import android.support.annotation.NonNull;
import android.support.annotation.Nullable;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import com.frist008.nixlibrary.NixCreatorHolder;
import com.frist008.nixlibrary.NixHolder;
import com.frist008.nixlibrary.cursor.NixCursorAdapter;
import com.frist008.nixlibrary.database.NixWhere;

@SuppressWarnings("unused")
public class NixStickyCursorAdapter extends NixCursorAdapter implements HeaderAdapter {

	private final NixCreatorHolder creatorHeaderHolder;

	public NixStickyCursorAdapter(@NonNull Context context,
	                              @NonNull Class<? extends NixHolder> holderClass,
	                              @LayoutRes int layoutRes,
	                              @NonNull Class<? extends NixHolder> holderHeaderClass,
	                              @LayoutRes int headerLayoutRes) {
		this(context, null, holderClass, layoutRes, holderHeaderClass, headerLayoutRes);
	}

	public NixStickyCursorAdapter(Context context,
	                              @Nullable Cursor cursor,
	                              @NonNull Class<? extends NixHolder> holderClass,
	                              @LayoutRes int layoutRes,
	                              @NonNull Class<? extends NixHolder> holderHeaderClass,
	                              @LayoutRes int headerLayoutRes) {
		super(context, cursor, holderClass, layoutRes);
		this.creatorHeaderHolder = new NixCreatorHolder(holderHeaderClass, headerLayoutRes);
	}

	@Deprecated
	@Override
	public View getHeaderView(int position, View parentView, ViewGroup parent) {
		return HeaderCursorAdapterUtils.getHeaderView(this, position, parentView, parent);
	}

	@Deprecated
	@Override
	public long getHeaderId(int position) {
		return HeaderCursorAdapterUtils.getViewTypeHeader(this, position);
	}

	@Deprecated
	@NonNull
	@Override
	public NixHolder newHeaderView(@NonNull LayoutInflater inflater,
	                               ViewGroup parent,
	                               int position,
	                               int viewType) {
		return creatorHeaderHolder.newView(inflater, parent);
	}

	@Deprecated
	@SuppressWarnings("unchecked")
	@Override
	public void bindHeaderView(@NonNull NixHolder holder, Cursor cursor) {
		holder.setId(cursor.getInt(cursor.getColumnIndex(NixWhere.NixCols.COLUMN_ID)));
		holder.setPosition(cursor.getPosition());
		holder.setAdapter(this);
		holder.bindView(cursor);
	}

	@Override
	public int getHeaderViewType(Cursor cursor, int position) {
		return 0;
	}
}
