package com.frist008.nixlibrary.database;

import android.content.ContentValues;
import android.database.Cursor;
import android.support.annotation.NonNull;
import android.support.annotation.Nullable;

import com.frist008.nixlibrary.database.utils.BooleanInt;

@SuppressWarnings("unused")
public class NixBoolean extends NixColumnType<NixBoolean, Boolean> {

	public NixBoolean(NixTableOrViewBean bean, String columnName) {
		super(bean, columnName);
	}

	public NixBoolean(@NonNull NixTableOrViewBean bean,
	                  @NonNull String columnName,
	                  @Nullable Boolean defValue) {
		super(bean, columnName, defValue);
	}

	public NixBoolean(@NonNull NixTableOrViewBean bean,
	                  @NonNull String columnName,
	                  @Nullable Boolean defValue,
	                  boolean index) {
		super(bean, columnName, defValue, false, index);
	}

	@Nullable
	@Override
	public Boolean getValue(Cursor cursor, int columnIndexOrThrow) {
		return cursor.getInt(columnIndexOrThrow) == BooleanInt.TRUE;
	}

	@Nullable
	@Override
	public Boolean get() {
		return super.get();
	}

	@SuppressWarnings("ConstantConditions")
	@Override
	void fillContentValue(ContentValues contentValues) {
		contentValues.put(toString(), hasValue() && get() ? BooleanInt.TRUE : BooleanInt.FALSE);
	}

	@Override
	Boolean[] newArrayForValues(int count) {
		return new Boolean[count];
	}

	@NonNull
	@Override
	protected Boolean getStandardDefaultValue() {
		return false;
	}

	@Override
	public String getType() {
		return INTEGER;
	}

	public void set(Integer value) {
		set(value == null ? null : value == BooleanInt.TRUE);
	}

	@Nullable
	@Override
	String getDBDefValue() {
		//noinspection ConstantConditions
		return hasDefValue() ? getDefaultValue() ? NixWhere.TRUE_STR : NixWhere.FALSE_STR : null;
	}
}
