package com.frist008.nixlibrary.database;

import android.content.ContentValues;
import android.database.Cursor;
import android.support.annotation.NonNull;
import android.support.annotation.Nullable;

@SuppressWarnings("unused")
public class NixByte extends NixColumnType<NixByte, byte[]> {
	private static final String BLOB = " BLOB ";

	public NixByte(NixTableOrViewBean bean, String columnName) {
		super(bean, columnName);
	}

	public NixByte(@NonNull NixTableOrViewBean bean, @NonNull String columnName, boolean unique) {
		super(bean, columnName, unique);
	}

	public NixByte(@NonNull NixTableOrViewBean bean,
	               @NonNull String columnName,
	               boolean unique,
	               boolean index) {
		super(bean, columnName, unique, index);
	}

	@Nullable
	@Override
	public byte[] getValue(Cursor cursor, int columnIndexOrThrow) {
		return cursor.getBlob(columnIndexOrThrow);
	}

	@Nullable
	@Override
	public byte[] get() {
		return super.get();
	}

	@Override
	void fillContentValue(ContentValues contentValues) {
		contentValues.put(toString(), get());
	}

	@Override
	byte[][] newArrayForValues(int count) {
		return new byte[count][];
	}

	@Override
	public String getType() {
		return BLOB;
	}

	@Deprecated
	@Nullable
	@Override
	public byte[] getDefaultValue() {
		return null;
	}

	@NonNull
	@Override
	protected byte[] getStandardDefaultValue() {
		return new byte[0];
	}

	@Deprecated
	@Nullable
	@Override
	String getDBDefValue() {
		//noinspection ConstantConditions
		return null;
	}
}
