package com.frist008.nixlibrary.database;

import android.content.ContentValues;
import android.database.Cursor;
import android.support.annotation.NonNull;
import android.support.annotation.Nullable;

@SuppressWarnings("unused")
public class NixDouble extends NixNumberType<NixDouble, Double> {

	public NixDouble(NixTableOrViewBean bean, String columnName) {

		super(bean, columnName);
	}

	public NixDouble(@NonNull NixTableOrViewBean bean, @NonNull String columnName, boolean unique) {
		super(bean, columnName, unique);
	}

	public NixDouble(@NonNull NixTableOrViewBean bean,
	                 @NonNull String columnName,
	                 boolean unique,
	                 boolean index) {
		super(bean, columnName, unique, index);
	}

	public NixDouble(@NonNull NixTableOrViewBean bean,
	                 @NonNull String columnName,
	                 @Nullable Double defValue) {
		super(bean, columnName, defValue);
	}

	public NixDouble(@NonNull NixTableOrViewBean bean,
	                 @NonNull String columnName,
	                 @Nullable Double defValue,
	                 boolean unique) {
		super(bean, columnName, defValue, unique);
	}

	public NixDouble(@NonNull NixTableOrViewBean bean,
	                 @NonNull String columnName,
	                 @Nullable Double defValue,
	                 boolean unique,
	                 boolean index) {
		super(bean, columnName, defValue, unique, index);
	}

	@Nullable
	@Override
	public Double getValue(Cursor cursor, int columnIndexOrThrow) {
		return cursor.getDouble(columnIndexOrThrow);
	}

	@Nullable
	@Override
	public Double get() {
		return super.get();
	}

	@Override
	void fillContentValue(ContentValues contentValues) {
		contentValues.put(toString(), get());
	}

	@Override
	Double[] newArrayForValues(int count) {
		return new Double[count];
	}

	@NonNull
	@Override
	protected Double getStandardDefaultValue() {
		return 0.0d;
	}

	@Nullable
	@Override
	public String getType() {
		return REAL;
	}

	@Nullable
	@Override
	String getDBDefValue() {
		//noinspection ConstantConditions
		return hasDefValue() ? getDefaultValue().toString() : null;
	}
}
