package com.frist008.nixlibrary.database;

import android.content.ContentValues;
import android.database.Cursor;
import android.support.annotation.NonNull;
import android.support.annotation.Nullable;

@SuppressWarnings("unused")
public class NixFloat extends NixNumberType<NixFloat, Float> {

	public NixFloat(NixTableOrViewBean bean, String columnName) {
		super(bean, columnName);
	}

	public NixFloat(@NonNull NixTableOrViewBean bean, @NonNull String columnName, boolean unique) {
		super(bean, columnName, unique);
	}

	public NixFloat(@NonNull NixTableOrViewBean bean,
	                @NonNull String columnName,
	                boolean unique,
	                boolean index) {
		super(bean, columnName, unique, index);
	}

	public NixFloat(@NonNull NixTableOrViewBean bean,
	                @NonNull String columnName,
	                @Nullable Float defValue) {
		super(bean, columnName, defValue);
	}

	public NixFloat(@NonNull NixTableOrViewBean bean,
	                @NonNull String columnName,
	                @Nullable Float defValue,
	                boolean unique) {
		super(bean, columnName, defValue, unique);
	}

	public NixFloat(@NonNull NixTableOrViewBean bean,
	                @NonNull String columnName,
	                @Nullable Float defValue,
	                boolean unique,
	                boolean index) {
		super(bean, columnName, defValue, unique, index);
	}

	@Nullable
	@Override
	public Float getValue(Cursor cursor, int columnIndexOrThrow) {
		return cursor.getFloat(columnIndexOrThrow);
	}

	@Nullable
	@Override
	public Float get() {
		return super.get();
	}

	@Override
	void fillContentValue(ContentValues contentValues) {
		contentValues.put(toString(), get());
	}

	@Override
	Float[] newArrayForValues(int count) {
		return new Float[count];
	}

	@NonNull
	@Override
	protected Float getStandardDefaultValue() {
		return 0.0f;
	}

	@Nullable
	@Override
	public String getType() {
		return REAL;
	}

	@Nullable
	@Override
	String getDBDefValue() {
		//noinspection ConstantConditions
		return hasDefValue() ? getDefaultValue().toString() : null;
	}
}
