package com.frist008.nixlibrary.database;

import android.content.ContentValues;
import android.database.Cursor;
import android.support.annotation.NonNull;
import android.support.annotation.Nullable;

@SuppressWarnings("unused")
public class NixInt extends NixNumberType<NixInt, Integer> {

	public NixInt(NixTableOrViewBean bean, String columnName) {
		super(bean, columnName);
	}

	public NixInt(@NonNull NixTableOrViewBean bean, @NonNull String columnName, boolean unique) {
		super(bean, columnName, unique);
	}

	public NixInt(@NonNull NixTableOrViewBean bean,
	              @NonNull String columnName,
	              boolean unique,
	              boolean index) {
		super(bean, columnName, unique, index);
	}

	public NixInt(@NonNull NixTableOrViewBean bean,
	              @NonNull String columnName,
	              @Nullable Integer defValue) {
		super(bean, columnName, defValue);
	}

	public NixInt(@NonNull NixTableOrViewBean bean,
	              @NonNull String columnName,
	              @Nullable Integer defValue,
	              boolean unique) {
		super(bean, columnName, defValue, unique);
	}

	public NixInt(@NonNull NixTableOrViewBean bean,
	              @NonNull String columnName,
	              @Nullable Integer defValue,
	              boolean unique,
	              boolean index) {
		super(bean, columnName, defValue, unique, index);
	}

	@Nullable
	@Override
	public Integer getValue(Cursor cursor, int columnIndexOrThrow) {
		return cursor.getInt(columnIndexOrThrow);
	}

	@Nullable
	@Override
	public Integer get() {
		return super.get();
	}

	@Override
	void fillContentValue(ContentValues contentValues) {
		contentValues.put(toString(), get());
	}

	@Override
	Integer[] newArrayForValues(int count) {
		return new Integer[count];
	}

	@NonNull
	@Override
	protected Integer getStandardDefaultValue() {
		return 0;
	}

	@Override
	public String getType() {
		return INTEGER;
	}

	@Nullable
	@Override
	String getDBDefValue() {
		//noinspection ConstantConditions
		return hasDefValue() ? getDefaultValue().toString() : null;
	}
}
