package com.frist008.nixlibrary.database;

import android.content.ContentValues;
import android.database.Cursor;
import android.support.annotation.NonNull;
import android.support.annotation.Nullable;

@SuppressWarnings("unused")
public class NixLong extends NixNumberType<NixLong, Long> {
	private static final String NUMERIC = " NUMERIC ";

	public NixLong(NixTableOrViewBean bean, String columnName) {
		super(bean, columnName);
	}

	public NixLong(@NonNull NixTableOrViewBean bean, @NonNull String columnName, boolean unique) {
		super(bean, columnName, unique);
	}

	public NixLong(@NonNull NixTableOrViewBean bean,
	               @NonNull String columnName,
	               boolean unique,
	               boolean index) {
		super(bean, columnName, unique, index);
	}

	public NixLong(@NonNull NixTableOrViewBean bean,
	               @NonNull String columnName,
	               @Nullable Long defValue) {
		super(bean, columnName, defValue);
	}

	public NixLong(@NonNull NixTableOrViewBean bean,
	               @NonNull String columnName,
	               @Nullable Long defValue,
	               boolean unique) {
		super(bean, columnName, defValue, unique);
	}

	public NixLong(@NonNull NixTableOrViewBean bean,
	               @NonNull String columnName,
	               @Nullable Long defValue,
	               boolean unique,
	               boolean index) {
		super(bean, columnName, defValue, unique, index);
	}

	@Nullable
	@Override
	public Long getValue(Cursor cursor, int columnIndexOrThrow) {
		return cursor.getLong(columnIndexOrThrow);
	}

	@Nullable
	@Override
	public Long get() {
		return super.get();
	}

	@Override
	void fillContentValue(ContentValues contentValues) {
		contentValues.put(toString(), get());
	}

	@Override
	Long[] newArrayForValues(int count) {
		return new Long[count];
	}

	@NonNull
	@Override
	protected Long getStandardDefaultValue() {
		return 0L;
	}

	@Override
	public String getType() {
		return NUMERIC;
	}

	@Nullable
	@Override
	String getDBDefValue() {
		//noinspection ConstantConditions
		return hasDefValue() ? getDefaultValue().toString() : null;
	}
}
