package com.frist008.nixlibrary.database;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class NixNameTableAs extends NixNameTable {

	private final Map<String, String> nameColMap = new HashMap<>();
	private final NixTable originalTable;

	public NixNameTableAs(NixTable originalTable) {
		this(originalTable, NixWhere.AS.trim());
	}

	public NixNameTableAs(NixTable originalTable, Object suffix) {
		super(originalTable.toString() + suffix);
		this.originalTable = originalTable;

		List<String> nameColList = getCols(new ArrayList<String>());

		for (String nameCol : nameColList) {
			nameColMap.put(nameCol, toString() + nameCol);
		}
	}

	public String getOriginalName() {
		return originalTable.toString();
	}

	public Map<String, String> getNameColMap() {
		return nameColMap;
	}

	protected List<String> getCols(List<String> nameColList) {
		@SuppressWarnings("unchecked")
		Map<String, NixColumnType> columnMap = originalTable.getBean().columnMap;

		for (String nameCol : columnMap.keySet()) {
			nameColList.add(nameCol);
		}
		return nameColList;
	}

	public String as(String originColName) {
		return getNameColMap().get(originColName);
	}
}
