package com.frist008.nixlibrary.database;

import android.support.annotation.NonNull;
import android.support.annotation.Nullable;

@SuppressWarnings("unused")
public class NixNotNullBoolean extends NixBoolean {

	public NixNotNullBoolean(@NonNull NixTableOrViewBean bean, @NonNull String columnName) {
		super(bean, columnName, null);
	}

	public NixNotNullBoolean(@NonNull NixTableOrViewBean bean,
	                         @NonNull String columnName,
	                         @Nullable Boolean defValue) {
		super(bean, columnName, defValue);
	}

	public NixNotNullBoolean(@NonNull NixTableOrViewBean bean,
	                         @NonNull String columnName,
	                         @Nullable Boolean defValue,
	                         boolean index) {
		super(bean, columnName, defValue, index);
	}

	@SuppressWarnings("ConstantConditions")
	@NonNull
	@Override
	public Boolean get() {
		return super.get();
	}

	@Override
	protected boolean isNotNull() {
		return true;
	}

	@Override
	public boolean isNullableValue() {
		return false;
	}

	@Override
	public void setNullableValue(boolean nullableValue) {
		super.setNullableValue(false);
	}
}
