package com.frist008.nixlibrary.database;

import android.support.annotation.NonNull;

@SuppressWarnings("unused")
public class NixNotNullByte extends NixByte {

	public NixNotNullByte(@NonNull NixTableOrViewBean bean, @NonNull String columnName) {
		super(bean, columnName);
	}

	public NixNotNullByte(@NonNull NixTableOrViewBean bean,
	                      @NonNull String columnName,
	                      boolean unique) {
		super(bean, columnName, unique);
	}

	public NixNotNullByte(@NonNull NixTableOrViewBean bean,
	                      @NonNull String columnName,
	                      boolean unique,
	                      boolean index) {
		super(bean, columnName, unique, index);
	}

	@SuppressWarnings("ConstantConditions")
	@NonNull
	@Override
	public byte[] get() {
		return super.get() == null && hasDefValue() ? getDefaultValue() : super.get();
	}

	@Override
	protected boolean isNotNull() {
		return true;
	}

	@Override
	public boolean isNullableValue() {
		return false;
	}

	@Override
	public void setNullableValue(boolean nullableValue) {
		super.setNullableValue(false);
	}
}
