package com.frist008.nixlibrary.database;

import android.support.annotation.NonNull;

@SuppressWarnings("unused")
public class NixNotNullFloat extends NixFloat {

	public NixNotNullFloat(@NonNull NixTableOrViewBean bean, @NonNull String columnName) {
		super(bean, columnName, null);
	}

	public NixNotNullFloat(@NonNull NixTableOrViewBean bean,
	                       @NonNull String columnName,
	                       boolean unique) {
		super(bean, columnName, null, unique);
	}

	public NixNotNullFloat(@NonNull NixTableOrViewBean bean,
	                       @NonNull String columnName,
	                       boolean unique,
	                       boolean index) {
		super(bean, columnName, null, unique, index);
	}

	public NixNotNullFloat(@NonNull NixTableOrViewBean bean,
	                       @NonNull String columnName,
	                       @NonNull Float defValue) {
		super(bean, columnName, defValue);
	}

	public NixNotNullFloat(@NonNull NixTableOrViewBean bean,
	                       @NonNull String columnName,
	                       @NonNull Float defValue,
	                       boolean unique) {
		super(bean, columnName, defValue, unique);
	}

	public NixNotNullFloat(@NonNull NixTableOrViewBean bean,
	                       @NonNull String columnName,
	                       @NonNull Float defValue,
	                       boolean unique,
	                       boolean index) {
		super(bean, columnName, defValue, unique, index);
	}

	@SuppressWarnings("ConstantConditions")
	@NonNull
	@Override
	public Float get() {
		return super.get();
	}

	@Override
	protected boolean isNotNull() {
		return true;
	}

	@Override
	public boolean isNullableValue() {
		return false;
	}

	@Override
	public void setNullableValue(boolean nullableValue) {
		super.setNullableValue(false);
	}
}
