package com.frist008.nixlibrary.database;

import android.support.annotation.NonNull;
import android.support.annotation.Nullable;

public abstract class NixNumberType<NixType extends NixColumnType, ValueType extends Number>
		extends NixColumnType<NixType, ValueType> {

	public NixNumberType(@NonNull NixTableOrViewBean bean, @NonNull String columnName) {
		super(bean, columnName);
	}

	public NixNumberType(@NonNull NixTableOrViewBean bean,
	                     @NonNull String columnName,
	                     boolean unique) {
		super(bean, columnName, unique);
	}

	public NixNumberType(@NonNull NixTableOrViewBean bean,
	                     @NonNull String columnName,
	                     boolean unique,
	                     boolean index) {
		super(bean, columnName, unique, index);
	}

	public NixNumberType(@NonNull NixTableOrViewBean bean,
	                     @NonNull String columnName,
	                     @Nullable ValueType defValue) {
		super(bean, columnName, defValue);
	}

	public NixNumberType(@NonNull NixTableOrViewBean bean,
	                     @NonNull String columnName,
	                     @Nullable ValueType defValue,
	                     boolean unique) {
		super(bean, columnName, defValue, unique);
	}

	public NixNumberType(@NonNull NixTableOrViewBean bean,
	                     @NonNull String columnName,
	                     @Nullable ValueType defValue,
	                     boolean unique,
	                     boolean index) {
		super(bean, columnName, defValue, unique, index);
	}

	public void setNotZero(ValueType number) {
		set(number == null || number instanceof Integer && number.intValue() == 0
		    || number instanceof Long && number.longValue() == 0L
		    || number instanceof Short && number.shortValue() == 0
		    || number instanceof Double && number.doubleValue() == 0.0d
		    || number instanceof Float && number.floatValue() == 0.0f
		    || number instanceof Byte && number.byteValue() == 0
		    ? null : number);
	}
}
