package com.frist008.nixlibrary.database;

import android.content.ContentValues;
import android.database.Cursor;
import android.support.annotation.NonNull;
import android.support.annotation.Nullable;

@SuppressWarnings("unused")
public class NixShort extends NixNumberType<NixShort, Short> {

	public NixShort(NixTableOrViewBean bean, String columnName) {
		super(bean, columnName);
	}

	public NixShort(@NonNull NixTableOrViewBean bean, @NonNull String columnName, boolean unique) {
		super(bean, columnName, unique);
	}

	public NixShort(@NonNull NixTableOrViewBean bean,
	                @NonNull String columnName,
	                boolean unique,
	                boolean index) {
		super(bean, columnName, unique, index);
	}

	public NixShort(@NonNull NixTableOrViewBean bean,
	                @NonNull String columnName,
	                @Nullable Short defValue) {
		super(bean, columnName, defValue);
	}

	public NixShort(@NonNull NixTableOrViewBean bean,
	                @NonNull String columnName,
	                @Nullable Short defValue,
	                boolean unique) {
		super(bean, columnName, defValue, unique);
	}

	public NixShort(@NonNull NixTableOrViewBean bean,
	                @NonNull String columnName,
	                @Nullable Short defValue,
	                boolean unique,
	                boolean index) {
		super(bean, columnName, defValue, unique, index);
	}

	@Nullable
	@Override
	public Short getValue(Cursor cursor, int columnIndexOrThrow) {
		return cursor.getShort(columnIndexOrThrow);
	}

	@Nullable
	@Override
	public Short get() {
		return super.get();
	}

	@Override
	void fillContentValue(ContentValues contentValues) {
		contentValues.put(toString(), get());
	}

	@Override
	Short[] newArrayForValues(int count) {
		return new Short[count];
	}

	@NonNull
	@Override
	protected Short getStandardDefaultValue() {
		return 0;
	}

	@Nullable
	@Override
	String getDBDefValue() {
		//noinspection ConstantConditions
		return hasDefValue() ? getDefaultValue().toString() : null;
	}

	@Override
	public String getType() {
		return INTEGER;
	}
}
