package com.frist008.nixlibrary.database;

import android.support.annotation.NonNull;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

@SuppressWarnings("unused")
public abstract class NixViewBean<Bean extends NixViewBean> extends NixTableOrViewBean<Bean> {
	protected static final int NONEXISTENT_COLUMN_ID = -1;

	final List<NixTableBean> tableList;

	@SuppressWarnings("unchecked")
	public NixViewBean() {
		tableList = new ArrayList<>();
		fillView(tableList);

		for (NixTableBean tableBean : tableList) {
			columnMap.putAll(tableBean.columnMap);
		}
	}

	protected abstract void fillView(List<NixTableBean> tableList);

	@Override
	@NonNull
	public abstract NixView getTableOrView();

	public List<NixTableBean> getTableList() {
		return Collections.unmodifiableList(tableList);
	}
}
