package com.frist008.nixlibrary.database.utils;

import com.frist008.nixlibrary.database.NixNameTableAs;
import com.frist008.nixlibrary.database.NixWhere;

@SuppressWarnings("unused")
public class NixSelectAllColumnBuilder {

	private static final char ALL_COLUMN = '*';

	private final StringBuilder builder = new StringBuilder();

	public NixSelectAllColumnBuilder append(Object table) {
		appendFirst().append(table).append(NixWhere.DOT).append(ALL_COLUMN);

		return this;
	}

	public NixSelectAllColumnBuilder append(NixNameTableAs nameTableAs) {
		for (String nameCol : nameTableAs.getNameColMap().keySet()) {
			appendFirst().append(nameTableAs).append(NixWhere.DOT).append(nameCol)
			             .append(NixWhere.AS).append(nameTableAs).append(nameCol);
		}

		return this;
	}

	private StringBuilder appendFirst() {
		if (builder.length() > 0) {
			builder.append(NixWhere.COMMA);
		}
		return builder;
	}

	@Override
	public String toString() {
		return builder.toString();
	}
}
