package com.frist008.nixlibrary.database.utils;

import android.support.annotation.NonNull;

import com.frist008.nixlibrary.database.NixView;
import com.frist008.nixlibrary.database.NixWhere;

import java.text.MessageFormat;

@SuppressWarnings("unused")
public class NixViewCreatorBuilder extends NixUnionBuilder {

	private static final String CREATE_VIEW = "CREATE VIEW IF NOT EXISTS {0}" + NixWhere.AS
	                                          + "SELECT {1} "
	                                          + "FROM {2} ";

	@NonNull
	private final NixView nameView;

	public NixViewCreatorBuilder(@NonNull NixView nameView,
	                             @NonNull NixSelectAllColumnBuilder select,
	                             @NonNull NixViewFromBuilder from) {
		super(select, from);
		this.nameView = nameView;
	}

	@Deprecated
	@Override
	public NixUnionBuilder having(@NonNull String having) {
		return this;
	}

	@Deprecated
	@Override
	public NixUnionBuilder groupBy(@NonNull String groupBy) {
		return this;
	}

	@Override
	public String toString() {
		return MessageFormat.format(CREATE_VIEW, nameView, getSelect(), getFrom()) + getBuilder();
	}
}
