package com.frist008.nixlibrary.recycler.cursor;

import android.database.Cursor;
import android.view.LayoutInflater;
import android.view.ViewGroup;

import com.frist008.nixlibrary.NixException;
import com.frist008.nixlibrary.NixHolder;
import com.frist008.nixlibrary.NixMultiCreatorHolder;
import com.frist008.nixlibrary.NixRecyclerViewHolder;

@SuppressWarnings("UnusedDeclaration")
public abstract class NixMultiCursorRecyclerAdapter extends NixCursorRecyclerAdapter {

	private final NixMultiCreatorHolder typeItemArr = new NixMultiCreatorHolder();

	@SuppressWarnings("ConstantConditions")
	public NixMultiCursorRecyclerAdapter() {
		super(null, 0);
		fillTypeItemArr(typeItemArr);

		if (typeItemArr.getCreatorHolderSparseArray().size() == 0) {
			throw new NixException("SparseArray not valid length (maybe SparseArray == 0?)");
		}
	}

	protected abstract void fillTypeItemArr(NixMultiCreatorHolder typeItemArr);

	protected abstract int getItemViewType(Cursor cursor);

	@Deprecated
	@Override
	public int getItemViewType(int position) {
		Cursor cursor = getCursor();
		return cursor != null && cursor.moveToPosition(position) ? getItemViewType(cursor) : 0;
	}

	@SuppressWarnings("deprecation")
	@Deprecated
	@Override
	public NixRecyclerViewHolder onCreateViewHolder(LayoutInflater inflater,
	                                                ViewGroup parent,
	                                                int viewType) {
		NixHolder holder = typeItemArr.getCreatorHolderSparseArray()
		                              .get(viewType)
		                              .newView(inflater, parent);
		return new NixRecyclerViewHolder(holder.getParentView(), holder);
	}

	@Deprecated
	@SuppressWarnings({"unchecked", "deprecation"})
	@Override
	public void onBindViewHolder(NixHolder holder, Cursor cursor) {
		holder.setViewType(getItemViewType(cursor));
		holder.setAdapter(this);
		holder.bindView(cursor);
	}
}
