package com.frist008.nixlibrary.recycler.list;

import android.util.SparseArray;
import android.view.LayoutInflater;
import android.view.ViewGroup;

import com.frist008.nixlibrary.NixArrayBean;
import com.frist008.nixlibrary.NixCreatorHolder;
import com.frist008.nixlibrary.NixException;
import com.frist008.nixlibrary.NixHolder;
import com.frist008.nixlibrary.NixMultiCreatorHolder;
import com.frist008.nixlibrary.NixRecyclerViewHolder;

import java.util.List;

@SuppressWarnings("unused")
public class NixMultiRecyclerAdapter extends NixRecyclerAdapter {

	private final SparseArray<NixCreatorHolder> typeItemArr;

	@SuppressWarnings("ConstantConditions")
	public NixMultiRecyclerAdapter(NixMultiCreatorHolder typeMultiItemArr,
	                               List<NixArrayBean> contentList) {
		super(contentList, null, 0);
		this.typeItemArr = typeMultiItemArr.getCreatorHolderSparseArray();

		if (typeItemArr.size() == 0) {
			throw new NixException("SparseArray not valid length (maybe SparseArray == 0?)");
		}
	}

	@SuppressWarnings("deprecation")
	@Deprecated
	@Override
	public NixRecyclerViewHolder onCreateViewHolder(ViewGroup parent, int viewType) {
		LayoutInflater inflater = LayoutInflater.from(parent.getContext());
		NixHolder holder = typeItemArr.get(viewType).newView(inflater, parent);
		return new NixRecyclerViewHolder(holder.getParentView(), holder);
	}

	@Override
	public int getItemViewType(int position) {
		return getContentList().get(position).getViewType();
	}
}
