package com.frist008.nixlibrary.recycler.list;

import android.support.annotation.LayoutRes;
import android.support.annotation.NonNull;
import android.support.v7.widget.RecyclerView;
import android.view.LayoutInflater;
import android.view.ViewGroup;

import com.frist008.nixlibrary.NixAdapter;
import com.frist008.nixlibrary.NixArrayBean;
import com.frist008.nixlibrary.NixCreatorHolder;
import com.frist008.nixlibrary.NixHolder;
import com.frist008.nixlibrary.NixRecyclerViewHolder;

import java.util.List;

@SuppressWarnings({"unused", "deprecation"})
public class NixRecyclerAdapter extends RecyclerView.Adapter<NixRecyclerViewHolder>
		implements NixAdapter<List> {

	private final List<? extends NixArrayBean> contentList;
	private final NixCreatorHolder creatorHolder;

	public NixRecyclerAdapter(List<? extends NixArrayBean> contentList,
	                          @NonNull Class<? extends NixHolder> holderClass,
	                          @LayoutRes int layoutRes) {
		this.contentList = contentList;
		this.creatorHolder = new NixCreatorHolder(holderClass, layoutRes);
	}

	@Deprecated
	@Override
	public NixRecyclerViewHolder onCreateViewHolder(ViewGroup parent, int viewType) {
		NixHolder holder = creatorHolder.newView(LayoutInflater.from(parent.getContext()),
		                                         parent);
		return new NixRecyclerViewHolder(holder.getParentView(), holder);
	}

	@Deprecated
	@SuppressWarnings("unchecked")
	@Override
	public void onBindViewHolder(NixRecyclerViewHolder viewHolder, int position) {
		NixHolder holder = viewHolder.getHolder();
		NixArrayBean content = contentList.get(position);

		holder.setPosition(position);
		holder.setViewType(content.getViewType());
		holder.setAdapter(this);
		holder.bindView(contentList.get(position));
	}

	@Override
	public int getItemCount() {
		return contentList.size();
	}

	@NonNull
	public List<? extends NixArrayBean> getContentList() {
		return contentList;
	}

	@Override
	public List<? extends NixArrayBean> getData() {
		return contentList;
	}
}
